So Tired !_! 逆水行舟, 不进则退!

29三/21

error: command ‘gcc’ failed with exit status 1 & ImportError: /usr/lib64/libstdc++.so.6: version `GLIBCXX_3.4.18′ not found

发布在 Nick Xu

1.error: command 'gcc' failed with exit status 1

今夜在CentOS release 6.9 和Python 2.7.3环境下,从源码安装pyltp,代码如下:

 

 $ git clone https://github.com/HIT-SCIR/pyltp
 $ git submodule init
 $ git submodule update
 $ python setup.py install # Mac系统出现版本问题使用 MACOSX_DEPLOYMENT_TARGET=10.7 python setup.py install

安装到最后一行:$ python setup.py install
报错:error: command 'gcc' failed with exit status 1

学习了CentOS6.5升级手动安装GCC4.8.2发现是系统自带的gcc(4.4.7) 版本太老所致,不能支持C++11的特性,要升级到4.8.2,以下是正确操作。

1.1获取安装包并解压

 

wget http://ftp.gnu.org/gnu/gcc/gcc-4.9.4/gcc-4.9.4.tar.bz2
tar -jxvf gcc-4.9.4.tar.bz2

此外,http://ftp.gnu.org/gnu/gcc 里面有所有的gcc版本供下载。

1.2 下载供编译需求的依赖项

参考文献Linux升级GCC 4.8.1清晰简明教程(Ubuntu 12.04 64位版为例)中说:这个神奇的脚本文件会帮我们下载、配置、安装依赖库,可以节约我们大量的时间和精力。

 

cd gcc-4.9.4 
./contrib/download_prerequisites 

1.3建立一个目录供编译出的文件存放

 

mkdir gcc-build
cd gcc-build

1.4 生成Makefile文件

 

../configure -enable-checking=release -enable-languages=c,c++ -disable-multilib

1.5 编译(注意:此步骤非常耗时)

 

make -j4

-j4选项是make对多核处理器的优化,如果不成功请使用 make,相关优化选项可以移步至参考文献Ubuntu下Vim+GCC+GDB安装及使用。

1.6、安装

 

sudo make install

验证安装
重启,然后查看gcc版本:

 

gcc -v

如下图安装成功

2. ImportError: /usr/lib64/libstdc++.so.6: version `GLIBCXX_3.4.18' not found (required by /usr/local/lib/python2.7/site-packages/pyltp-0.2.1-py2.7-linux-x86_64.egg/pyltp.so)

运行pyltp程序时报错:

 

ImportError: /usr/lib64/libstdc++.so.6: version `GLIBCXX_3.4.18' not found 
(required by /usr/local/lib/python2.7/site-packages/pyltp-0.2.1-py2.7-linux-x86_64.egg/pyltp.so)

学习Linux下GLIBCXX和GLIBC版本低造成的编译错误的解决方案后发现是一个是关于C++的系统版本库libstdc++版本过低的问题。

1.1首先查看错误信息提示中的lib文件的信息

 

$ strings /usr/lib/x86_64-linux-gnu/libstdc++.so.6 | grep GLIBC 

这里是打印 libstdc++.so.6的输出信息中限定(grep) GLIBC库的信息,查看当前GLIBCXX版本结果如图所示:

确实比较旧了,那么我们有新版本么?我们安装了gcc 4.8.0,按理说应该已经装了新版的libstdC++.,如果没有,可以去网上下一个。

先在本机找:

 

find / -name libstdc++.so.6*

结果如图所示:

我们发现,gcc安装时把/libstdc++.so.6.0.18 安装到了/usr/local/lib64下,但并没有改变libstdc++.so.6的链接指向。那么我们手动来更新软链接(也可以直接指向/usr/local下的文件,不用拷贝, 看各自的文件管理习惯)

 

$ cp /usr/local/lib64/libstdc++.so.6.0.18 /usr/lib/x86_64-linux-gnu
$ rm -rf /usr/lib64/libstdc++.so.6
$ ln -s /usr/lib/x86_64-linux-gnu/libstdc++.so.6.0.18 /usr/lib/x86_64-linux-gnu/libstdc++.so.6
$ strings /usr/lib/x86_64-linux-gnu/libstdc++.so.6 | grep GLIBC

然后更新成功,结果如下图:

此时再运行.py文件,GLIBCXX的问题没有了。

   
site
site